float targetX;
float targetY;
int gl = 250;    // generation length in frames
int gc = 0;      // current generation age
int gTotal = 0;  // generations

Organism[] population;
int popSize = 100;
int winCount = 10;

Organism[] winners;

void setup() {
  frameRate(25);
  size(600,400);
  targetX = width/2;
  targetY = height/2;
  population = new Organism[popSize];
  winners = new Organism[0];
  for (int i=0; i<population.length; i++) {
    population[i] = new Organism();
  }
  background(255);
}

void draw() {
  if (gc > gl) {
    ArrayList allFit = new ArrayList();
    allFit.add(population[0]);
    for (int i=1; i<population.length; i++) {
      float f = population[i].fitness();
      int pos = 0;
      while (pos<allFit.size()) {
        Organism o = (Organism)allFit.get(pos);
        if (f > o.fitness()) {
          allFit.add(pos,population[i]);
          pos = allFit.size();
        } else {
          pos++;
          if (pos == allFit.size()) {
            allFit.add(pos,population[i]);
            pos++;
          }
        }
      }
    }
    winners = new Organism[winCount];
    Organism[] newPop = new Organism[population.length];
    for (int i=0; i<winCount; i++) {
      Organism o = (Organism)allFit.get(i);
      winners[i] = o;
      println("winner "+i+": "+o.fitness()+" at "+o.x+", "+o.y);
      int childCount = population.length/winCount;
      for (int j=0; j<childCount; j++) {
        Organism other = (Organism)allFit.get(int(random(0,allFit.size())));
        DNA newDna = o.dna.crossOverRandom(other.dna);
        newDna.mutate();
        newPop[i+j*winCount] = new Organism(newDna);
      }
    }
    population = newPop;
    gc = 0;
    gTotal++;
    println("Next generation: "+gTotal);
    background(255);
    return;
  }
  gc++;
  fill(255,2);
  rect(0,0,width,height);
  ellipseMode(CENTER);
  for (int i=0; i<population.length; i++) {
    population[i].move();
    population[i].draw();
  }
}

void mouseReleased() {
  targetX = mouseX;
  targetY = mouseY;
}

void mouseDragged() {
  targetX = mouseX;
  targetY = mouseY;
}

void keyPressed() {
  if (key=='w') {
    println("Last generation's winners:");
    for (int i=0; i<winners.length; i++) {
      for (int j=0; j<winners[i].dna.dna.length; j++) {
        print(winners[i].dna.dna[j]+",");
      }
      println();
    }
  }
}
